function uploaddialog(){
	
	var ioService = Components
		.classes["@mozilla.org/network/io-service;1"]
		.getService(Components.interfaces.nsIIOService);
	var nsIFilePicker = Components
		.classes["@mozilla.org/filepicker;1"]
		.createInstance(Components.interfaces.nsIFilePicker);
	
	nsIFilePicker.init(
		window,
		"Open file",
		Components.interfaces.nsIFilePicker.modeOpen
	);
	
	nsIFilePicker.appendFilter("All files", "*.*");
	
	if (nsIFilePicker.show() == Components.interfaces.nsIFilePicker.returnOK)
	{
		obj_uploader.fnc_uploadFile(
			nsIFilePicker.file,
			
			function(reqResponse, pendingUploadCount){
				alert('pending uploads count: '+pendingUploadCount)
				alert('received response: '+reqResponse)
			}
		);
	}
}

/*var listener = {
	handleEvent: function( event ) {
		dump( "\n" +event.target );
	}
}*/


function refreshUploadLabels ()
{
	for (var i = 0; i < Cyclone3Uploads.pool.labels.length; i++)
	{
		if (Cyclone3Uploads.count_global > 0)
		{
			Cyclone3Uploads.pool.labels[i].setAttribute('hidden', 'false');
			Cyclone3Uploads.pool.labels[i].setAttribute('value', Cyclone3Uploads.count_global + ' ' + ui.locale.getStringFromName('upload.upload'));
		} else	
		{
			Cyclone3Uploads.pool.labels[i].setAttribute('hidden', 'true');
		}
	}
	
}



var gen_uploader = function(){}

gen_uploader.prototype.scheduler = null

gen_uploader.prototype.arr_uploads = {}
gen_uploader.prototype.arr_upload_watchers = {}
gen_uploader.prototype.var_uploads_count = 0
gen_uploader.prototype.var_uploads_counter = 0

gen_uploader.prototype.var_uploadUrl = null;

gen_uploader.prototype.fnc_startScheduler = function ()
{
	log('[upload.js] fnc_startScheduler');

	var win = ui.probeOpenWindow('uploads');
	
	if(win)
	{
		win.refreshView();
	}
	
	//if (fullsize / 1024 > 500) 
	//{
		if(win)
		{
			//win.focus();
		} else
		{
			var wasclosed = Cyclone3Uploads.windowClosed;
			
			//if (wasclosed != 1)
			//{
			
			win = openDialog(
				"chrome://c3xuladmin/content/uploads.xul",
				'uploads',
				"",
				Cyclone3.domain
			);
			//win.focus();
			//}
		}
	//}
	
	var tthis = this;
	
	if (!tthis.scheduler)
	{
		log('[upload.js:obj_uploader] {fnc_startScheduler} setting up');
		
		tthis.scheduler = window.setInterval(
			function () {
				log(Cyclone3Uploads.pool.uploads);
				log(Object.keys(Cyclone3Uploads.pool.uploads));
				log('[upload.js:obj_uploader] {fnc_startScheduler} scheduled length: '+Object.keys(Cyclone3Uploads.pool.uploads).length);
				
				var finishedUploadCount = 0;
				var runningUploadCount = 0;
				
				if (Object.keys(Cyclone3Uploads.pool.uploads).length)
				{
					Object.keys(Cyclone3Uploads.pool.uploads).sort().forEach(
						function(uploadId)
						{
							log('---------------------------------------------')
							
							log('[upload.js:obj_uploader] {fnc_startScheduler} checking uploadId '+uploadId)
							var tmpUpload = Cyclone3Uploads.pool.uploads[uploadId];
							
							//for(var tmp in tmpUpload)
							//{
							//	log('  ' + tmp + ': ' + tmpUpload[tmp])
							//}
							
							if (tmpUpload['finished'])
							{
								log('[upload.js:obj_uploader] {fnc_startScheduler}  this upload has finished with status: '+tmpUpload['finished']);
								finishedUploadCount++;
							}
							if (tmpUpload['started'] == 0)
							{
								if (runningUploadCount >= Cyclone3Uploads.maxSimultaneous)
								{
									// stop! don't upload more than 5 simultaneously!
									log('[upload.js:obj_uploader] {fnc_startScheduler}  sorry, ' + Cyclone3Uploads.maxSimultaneous + ' or more uploads are running, gotta wait with this one ...');
								}
								else
								{
									log('[upload.js:obj_uploader] {fnc_startScheduler}  this upload has not yet started, starting ...');
									tthis.fnc_uploadFileProceed(Cyclone3Uploads.pool.uploads[uploadId]);
									runningUploadCount++;
								}
							}
							if (tmpUpload['started'] == 1 && !tmpUpload['finished']) {
								log('[upload.js:obj_uploader] {fnc_startScheduler}  this upload has started and has not finished yet');
								runningUploadCount++;
							}
						}
					)
					
					log('[upload.js:obj_uploader] {fnc_startScheduler} finished uploads: '+finishedUploadCount);
					log('[upload.js:obj_uploader] {fnc_startScheduler} running uploads: '+runningUploadCount);
				}
				/*	bs, we need to go through storage
				if (Object.keys(tthis.arr_uploads).length)
				{
					Object.keys(tthis.arr_uploads).sort().forEach(
						function(uploadId)
						{
							log('checking uploadId '+uploadId)
							var tmpUpload = Cyclone3Uploads.pool.uploads[uploadId];
							for(var tmp in tmpUpload)
							{
								log(tmp)
							}
							if (tmpUpload['finished'])
							{
								finishedUploadCount++;
							}
							if (tmpUpload['started'] == 0)
							{
								tthis.fnc_uploadFileProceed(Cyclone3Uploads.pool.uploads[uploadId]);
							}
							if (tmpUpload['started'] == 1 && !tmpUpload['finished']) {
								runningUploadCount++;
							}
						}
					)
					
					log('finished uploads: '+finishedUploadCount);
					log('finished uploads: '+runningUploadCount);
				}
*/
				
				//if (!Object.keys(tthis.arr_uploads).length) {
				if(runningUploadCount == 0) {
					log('[upload.js:obj_uploader] {fnc_startScheduler} all uploads finished');
					window.clearInterval(tthis.scheduler);
					tthis.scheduler = null;
				}
			},
			1000
		);
	}
}

gen_uploader.prototype.fnc_uploadFile = function (obj_nsIFile, fnc_callback)
{
	log('[upload.js] {fnc_uploadFile} Cyclone3Uploads count: '+Cyclone3Uploads.count);
	
	if(this.var_uploadUrl===null)
	{
		alert("[upload.js:obj_uploader] {fnc_uploadFile} No upload url defined!");
	}
	const boundaryString = new Date().getTime()
	var tthis = this
	
	var nsIMultiplexInputStream = Components
		.classes["@mozilla.org/io/multiplex-input-stream;1"]
		.createInstance(Components.interfaces.nsIMultiplexInputStream)
	
	var nsIStringInputStream = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	
	if(!nsIMultiplexInputStream)
	{
		log("Error [fnc_init]: No output stream")
		return null
	}
	else
	{
		Cyclone3Uploads.counter++;
		
		tthis.var_uploads_counter = Cyclone3Uploads.counter + 0;
		
		Cyclone3Uploads.count++;
		
		tthis.var_uploads_count = Cyclone3Uploads.count + 0;
		
		Cyclone3Uploads.count_global++;
		
		refreshUploadLabels();
		
		var tmpCounterID = tthis.var_uploads_counter;
		
		var fullsize = nsIMultiplexInputStream.available();

		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID] = {};
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['upload_id'] = 'upload'+tmpCounterID;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['file'] = obj_nsIFile;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['filename'] = obj_nsIFile.leafName;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['parent_object'] = tthis;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['started'] = 0;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['finished'] = 0;
		Cyclone3Uploads.pool.uploads['upload'+tmpCounterID]['callback'] = fnc_callback;
		
		tthis.arr_uploads['upload'+tmpCounterID] = new XMLHttpRequest();
		
/*
		var win = ui.probeOpenWindow('uploads');
		
		if(win)
		{
			win.refreshView();
		}
		
		//if (fullsize / 1024 > 500) 
		//{
			if(win)
			{
				//win.focus();
			} else
			{
				var wasclosed = Cyclone3Uploads.windowClosed;
				
				//if (wasclosed != 1)
				//{
				
				win = openDialog(
					"chrome://c3xuladmin/content/uploads.xul",
					'uploads',
					"",
					Cyclone3.domain
				);
				//win.focus();
				//}
			}
		//}
*/
	}
}

gen_uploader.prototype.fnc_uploadFileProceed = function (uploadObject)
{
	log('starting upload id: '+uploadObject['upload_id'])

	const boundaryString = new Date().getTime()
	
	var tthis = this
	
	var tmp_file = uploadObject.file;
	var tmp_upload_id = uploadObject.upload_id;
	
	Cyclone3Uploads.pool.uploads[tmp_upload_id]['started'] = 1;
	
	var nsIMultiplexInputStream = Components
		.classes["@mozilla.org/io/multiplex-input-stream;1"]
		.createInstance(Components.interfaces.nsIMultiplexInputStream)
	
	var nsIStringInputStream = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	
	nsIStringInputStream.setData(
		"\r\n-----------------------------"
		+ boundaryString
		+ "\r\nContent-Disposition: form-data; name=\"userfile\"; filename=\""
		+ tmp_file.leafName
		+ "\"\r\n\r\n",
		-1
	)
	
	nsIMultiplexInputStream.appendStream(nsIStringInputStream);
	
	//create a binary stream
	var nsIFileInputStream = Components
		.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance(Components.interfaces.nsIFileInputStream)
	nsIFileInputStream.init(
		tmp_file,
		1,
		1,
		Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF
	)
	var nsIBufferedInputStream = Components
		.classes["@mozilla.org/network/buffered-input-stream;1"]
		.createInstance(Components.interfaces.nsIBufferedInputStream)
	nsIBufferedInputStream.init(nsIFileInputStream, 4096)
	
	nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
	
	var nsIStringInputStream_end = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	nsIStringInputStream_end.setData(
		"\r\n" + "-----------------------------" + boundaryString + "--\r\n",
		-1
	)
	
	nsIMultiplexInputStream.appendStream(nsIStringInputStream_end)
	
	if(!nsIMultiplexInputStream)
	{
		log("Error [fnc_init]: No output stream")
		return null
	}
	else
	{
		var fullsize = nsIMultiplexInputStream.available();

		tthis.arr_uploads['upload'+tthis.var_uploads_counter] = new XMLHttpRequest();
		
		var req = tthis.arr_uploads[tmp_upload_id];
		
		var upload_stats = {};
		upload_stats.size = 0;
		upload_stats.loaded = 0;
		upload_stats.finished = 0;
		
		req.upload.onprogress = function(evt)
		{
			//log('onuploadprogress');
			
			if (evt.lengthComputable)
			{
				upload_stats.loaded = evt.loaded;
				upload_stats.size = evt.total;
				
				//Cyclone3Uploads.pool.uploads[tmp_upload_id]['started'] = 1;
				Cyclone3Uploads.pool.uploads[tmp_upload_id]['total'] = evt.total;
				Cyclone3Uploads.pool.uploads[tmp_upload_id]['loaded'] = evt.loaded;
			}
		}
		
		req.open("POST", tthis.var_uploadUrl, true);
		req.setRequestHeader(
			"Content-Type",
			"multipart/form-data; charset: utf-8; boundary=---------------------------" + boundaryString
		)
		
		//creating listener
		req.onreadystatechange = function(event)
		{
			log('REQUEST: readyState:' + req.readyState + ' status: ' + req.status);
			// Check response
			if (req.readyState == 4)
			{
				var failedRequest = 0;
				// Clear Timeout
				try
				{
					if (req.status == 200)
					{
						//alles gute
						//alert(req.responseText);
						delete tthis.arr_uploads[tmp_upload_id]
						Cyclone3Uploads.count--;
						tthis.var_uploads_count = Cyclone3Uploads.count + 0;
						
						Cyclone3Uploads.pool.uploads[tmp_upload_id]['callback'](req.responseText, tthis.var_uploads_count, tmp_file);
						upload_stats.finished = 1;
						
						log('setting finished status for '+tmp_upload_id);
						log('setting all right status for '+tmp_upload_id);
						
						Cyclone3Uploads.pool.uploads[tmp_upload_id]['finished'] = 1;
						Cyclone3Uploads.pool.uploads[tmp_upload_id]['allright'] = 1;
						
						Cyclone3Uploads.count_global--;
						
						refreshUploadLabels();
					}
					else
					{
						alert('Failure: ' + req.statusText + ' ' + req.responseText);
						failedRequest = 1;
					}
				}
				catch(e)
				{
					log('Failure: ' + e + ' ' + req.status + ' ' + req.responseText);
					failedRequest = 1;
					
				}
				
				if(failedRequest)
				{
					delete tthis.arr_uploads[tmp_upload_id];
					
					log('setting badly finished status for '+tmp_upload_id);
					
					Cyclone3Uploads.pool.uploads[tmp_upload_id]['finished'] = 2;
					
					Cyclone3Uploads.count--;
					
					tthis.var_uploads_count = Cyclone3Uploads.count + 0;
					
					Cyclone3Uploads.count_global--;
					
					refreshUploadLabels();
					upload_stats.finished = 2;
					// Error
					//handler.fnc_handleError(
					//	{
					//		IDRequest: id,
					//		errorComponent: 'onreadystatechange',
					//		errorString: 'Could not connect - Domain or connection not available.'
					//	}
					//)
				}
				
				return
			}
			return
		}
		
		req.send(nsIMultiplexInputStream);
		
		window.addEventListener(
			"close",
			function(){
				req.abort(); 
				
				Cyclone3Uploads.pool.uploads[tmp_upload_id]['finished'] = 2;
				
				Cyclone3Uploads.count_global--;
				
				refreshUploadLabels();
			},
			false
		);
	}
}


var obj_uploader = new gen_uploader()

obj_uploader.var_uploadUrl = window.arguments[0].transport_URI + 'upload.pl';